_adc_inter:
;sin.c,16 :: 		void adc_inter() iv IVT_INT_ADC1_2 // adc interrupt after EOC
;sin.c,18 :: 		ADC1_SRbits.EOC=0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(ADC1_SRbits+0)
MOVT	R0, #hi_addr(ADC1_SRbits+0)
STR	R1, [R0, #0]
;sin.c,20 :: 		if(data_send_time==0)// change buffer only if it is not used
MOVW	R0, #lo_addr(_data_send_time+0)
MOVT	R0, #hi_addr(_data_send_time+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_adc_inter0
;sin.c,22 :: 		led=0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
STR	R1, [R0, #0]
;sin.c,23 :: 		if(num<BUF_DEPTH)// collect buffer
MOVW	R0, #lo_addr(_num+0)
MOVT	R0, #hi_addr(_num+0)
LDRH	R0, [R0, #0]
CMP	R0, #1000
IT	CS
BCS	L_adc_inter1
;sin.c,25 :: 		data_int[num]=ADC1_DRbits.DATA;
MOVW	R2, #lo_addr(_num+0)
MOVT	R2, #hi_addr(_num+0)
LDRH	R0, [R2, #0]
LSLS	R1, R0, #1
MOVW	R0, #lo_addr(_data_int+0)
MOVT	R0, #hi_addr(_data_int+0)
ADDS	R1, R0, R1
MOVW	R0, #lo_addr(ADC1_DRbits+0)
MOVT	R0, #hi_addr(ADC1_DRbits+0)
LDRH	R0, [R0, #0]
UBFX	R0, R0, #0, #16
STRH	R0, [R1, #0]
;sin.c,26 :: 		num++;
MOV	R0, R2
LDRH	R0, [R0, #0]
ADDS	R0, R0, #1
STRH	R0, [R2, #0]
;sin.c,27 :: 		}
IT	AL
BAL	L_adc_inter2
L_adc_inter1:
;sin.c,30 :: 		num=0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_num+0)
MOVT	R0, #hi_addr(_num+0)
STRH	R1, [R0, #0]
;sin.c,31 :: 		data_send_time=1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_data_send_time+0)
MOVT	R0, #hi_addr(_data_send_time+0)
STRB	R1, [R0, #0]
;sin.c,32 :: 		}
L_adc_inter2:
;sin.c,33 :: 		led=1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
STR	R1, [R0, #0]
;sin.c,34 :: 		}
L_adc_inter0:
;sin.c,35 :: 		}
L_end_adc_inter:
BX	LR
; end of _adc_inter
_timer_3_init:
;sin.c,37 :: 		void timer_3_init()// 1000Hz
;sin.c,39 :: 		RCC_APB1ENR.TIM3EN = 1;       // Enable clock gating for timer module
MOVS	R3, #1
SXTB	R3, R3
MOVW	R0, #lo_addr(RCC_APB1ENR+0)
MOVT	R0, #hi_addr(RCC_APB1ENR+0)
STR	R3, [R0, #0]
;sin.c,40 :: 		TIM3_CR1.CEN = 0;             // Disable timer
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TIM3_CR1+0)
MOVT	R0, #hi_addr(TIM3_CR1+0)
STR	R1, [R0, #0]
;sin.c,41 :: 		TIM3_PSC = 7199;              // Set timer prescaler.
MOVW	R1, #7199
MOVW	R0, #lo_addr(TIM3_PSC+0)
MOVT	R0, #hi_addr(TIM3_PSC+0)
STR	R1, [R0, #0]
;sin.c,42 :: 		TIM3_ARR = 9;                //
MOVS	R1, #9
MOVW	R0, #lo_addr(TIM3_ARR+0)
MOVT	R0, #hi_addr(TIM3_ARR+0)
STR	R1, [R0, #0]
;sin.c,43 :: 		TIM3_CR2bits.MMS=2;           // The update event is selected as trigger output (TRGO)
MOVS	R2, #2
MOVW	R1, #lo_addr(TIM3_CR2bits+0)
MOVT	R1, #hi_addr(TIM3_CR2bits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #3
STRB	R0, [R1, #0]
;sin.c,44 :: 		TIM3_CR1.CEN = 1;             // Enable timer
MOVW	R0, #lo_addr(TIM3_CR1+0)
MOVT	R0, #hi_addr(TIM3_CR1+0)
STR	R3, [R0, #0]
;sin.c,45 :: 		}
L_end_timer_3_init:
BX	LR
; end of _timer_3_init
_ADC_init:
;sin.c,47 :: 		void ADC_init(void)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;sin.c,49 :: 		GPIO_Analog_Input(&GPIOA_BASE, _GPIO_PINMASK_0);// channel 0
MOVW	R1, #1
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_GPIO_Analog_Input+0
;sin.c,51 :: 		RCC_APB2ENRbits.ADC1EN=1;       //enable clock on ADC1
MOVS	R3, #1
SXTB	R3, R3
MOVW	R0, #lo_addr(RCC_APB2ENRbits+0)
MOVT	R0, #hi_addr(RCC_APB2ENRbits+0)
STR	R3, [R0, #0]
;sin.c,52 :: 		ADC1_CR2bits.EXTSEL=4;          //Timer 3 TRGO event
MOVS	R2, #4
MOVW	R1, #lo_addr(ADC1_CR2bits+0)
MOVT	R1, #hi_addr(ADC1_CR2bits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #17, #3
STR	R0, [R1, #0]
;sin.c,53 :: 		ADC1_CR2bits.EXTTRIG=1;         //External trigger for ADC on
MOVW	R0, #lo_addr(ADC1_CR2bits+0)
MOVT	R0, #hi_addr(ADC1_CR2bits+0)
STR	R3, [R0, #0]
;sin.c,54 :: 		ADC1_SMPR2bits.SMP0=1;          //Sample time 7.5 cycles
MOVS	R2, #1
MOVW	R1, #lo_addr(ADC1_SMPR2bits+0)
MOVT	R1, #hi_addr(ADC1_SMPR2bits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #0, #3
STRB	R0, [R1, #0]
;sin.c,55 :: 		ADC1_CR1bits.EOCIE=1;           //Interrupt enable for EOC
MOVW	R0, #lo_addr(ADC1_CR1bits+0)
MOVT	R0, #hi_addr(ADC1_CR1bits+0)
STR	R3, [R0, #0]
;sin.c,56 :: 		ADC1_CR2bits.ADON=1;            //ADC enable
MOVW	R0, #lo_addr(ADC1_CR2bits+0)
MOVT	R0, #hi_addr(ADC1_CR2bits+0)
STR	R3, [R0, #0]
;sin.c,57 :: 		NVIC_IntEnable(IVT_INT_ADC1_2); //Interrupt enable for ADC1_2
MOVW	R0, #34
BL	_NVIC_IntEnable+0
;sin.c,58 :: 		}
L_end_ADC_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _ADC_init
_init_TIM4:
;sin.c,63 :: 		void init_TIM4()// init timer for PWM by table
;sin.c,65 :: 		RCC_APB1ENRbits.TIM4EN=1;      //enable clock on timer 4
MOVS	R3, #1
SXTB	R3, R3
MOVW	R0, #lo_addr(RCC_APB1ENRbits+0)
MOVT	R0, #hi_addr(RCC_APB1ENRbits+0)
STR	R3, [R0, #0]
;sin.c,66 :: 		TIM4_CCERbits.CC3E=1;          //CC4 channel configured as output
MOVW	R0, #lo_addr(TIM4_CCERbits+0)
MOVT	R0, #hi_addr(TIM4_CCERbits+0)
STR	R3, [R0, #0]
;sin.c,67 :: 		TIM4_CCMR2_Outputbits.OC3M=6;  //Output compare 3 mode (PWM)
MOVS	R2, #6
MOVW	R1, #lo_addr(TIM4_CCMR2_Outputbits+0)
MOVT	R1, #hi_addr(TIM4_CCMR2_Outputbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #3
STRB	R0, [R1, #0]
;sin.c,68 :: 		TIM4_CCMR2_Outputbits.OC3PE=1; //Output compare 3 preload enable
MOVW	R0, #lo_addr(TIM4_CCMR2_Outputbits+0)
MOVT	R0, #hi_addr(TIM4_CCMR2_Outputbits+0)
STR	R3, [R0, #0]
;sin.c,69 :: 		TIM4_DIERbits.CC3DE=1;         //Capture/Compare 3 DMA request enable
MOVW	R0, #lo_addr(TIM4_DIERbits+0)
MOVT	R0, #hi_addr(TIM4_DIERbits+0)
STR	R3, [R0, #0]
;sin.c,70 :: 		TIM4_CR1bits.CEN=1;            //Counter enable
MOVW	R0, #lo_addr(TIM4_CR1bits+0)
MOVT	R0, #hi_addr(TIM4_CR1bits+0)
STR	R3, [R0, #0]
;sin.c,71 :: 		TIM4_CR1bits.ARPE=1;           //Auto-reload preload enable
MOVW	R0, #lo_addr(TIM4_CR1bits+0)
MOVT	R0, #hi_addr(TIM4_CR1bits+0)
STR	R3, [R0, #0]
;sin.c,72 :: 		TIM4_PSC=19;                   //Prescaler value
MOVS	R1, #19
MOVW	R0, #lo_addr(TIM4_PSC+0)
MOVT	R0, #hi_addr(TIM4_PSC+0)
STR	R1, [R0, #0]
;sin.c,73 :: 		TIM4_ARR=999;                 //max count
MOVW	R1, #999
MOVW	R0, #lo_addr(TIM4_ARR+0)
MOVT	R0, #hi_addr(TIM4_ARR+0)
STR	R1, [R0, #0]
;sin.c,74 :: 		TIM4_CCR3=500;                //CCR3 is the value to be loaded in the actual capture/compare 3 register (preload value).
MOVW	R1, #500
MOVW	R0, #lo_addr(TIM4_CCR3+0)
MOVT	R0, #hi_addr(TIM4_CCR3+0)
STR	R1, [R0, #0]
;sin.c,75 :: 		}
L_end_init_TIM4:
BX	LR
; end of _init_TIM4
_init_DMA:
;sin.c,77 :: 		void init_DMA()// init sending data from table to timer without CPU  5ch
;sin.c,79 :: 		RCC_AHBENRbits.DMA1EN=1; //DMA1 clock enable
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RCC_AHBENRbits+0)
MOVT	R0, #hi_addr(RCC_AHBENRbits+0)
STR	R1, [R0, #0]
;sin.c,80 :: 		DMA1_CPAR5=&TIM4_CCR3;   //DMA1 channel 5 peripheral address register(set address of TIM4_CCR3)
MOVW	R1, #lo_addr(TIM4_CCR3+0)
MOVT	R1, #hi_addr(TIM4_CCR3+0)
MOVW	R0, #lo_addr(DMA1_CPAR5+0)
MOVT	R0, #hi_addr(DMA1_CPAR5+0)
STR	R1, [R0, #0]
;sin.c,81 :: 		DMA1_CMAR5=&sinTable;    //DMA1 channel x memory address register(set table address)
MOVW	R1, #lo_addr(_sinTable+0)
MOVT	R1, #hi_addr(_sinTable+0)
MOVW	R0, #lo_addr(DMA1_CMAR5+0)
MOVT	R0, #hi_addr(DMA1_CMAR5+0)
STR	R1, [R0, #0]
;sin.c,82 :: 		DMA1_CNDTR5=SIN_STEPS;   //DMA channel x number of data register
MOVS	R1, #120
MOVW	R0, #lo_addr(DMA1_CNDTR5+0)
MOVT	R0, #hi_addr(DMA1_CNDTR5+0)
STR	R1, [R0, #0]
;sin.c,83 :: 		DMA1_CCR5=0x000005B1;    //EN=1(Channel enable),DIR=1(Data transfer direction:Read from memory),CIRC=1(Circular mode enabled),MINC=1(Memory increment mode enabled),PSIZE=MSIZE=01(16-bits)
MOVW	R1, #1457
MOVW	R0, #lo_addr(DMA1_CCR5+0)
MOVT	R0, #hi_addr(DMA1_CCR5+0)
STR	R1, [R0, #0]
;sin.c,84 :: 		}
L_end_init_DMA:
BX	LR
; end of _init_DMA
_init_GPIO:
;sin.c,86 :: 		void init_GPIO()// init gpio to work with timer
;sin.c,88 :: 		RCC_APB2ENRbits.IOPBEN=1; //IO port B clock enable
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RCC_APB2ENRbits+0)
MOVT	R0, #hi_addr(RCC_APB2ENRbits+0)
STR	R1, [R0, #0]
;sin.c,89 :: 		RCC_APB2ENRbits.AFIOEN=1; //Alternate function IO clock enable
MOVW	R0, #lo_addr(RCC_APB2ENRbits+0)
MOVT	R0, #hi_addr(RCC_APB2ENRbits+0)
STR	R1, [R0, #0]
;sin.c,90 :: 		GPIOB_CRHbits.MODE8=1;    //10: Alternate function output Push-pull
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOB_CRHbits+0)
MOVT	R1, #hi_addr(GPIOB_CRHbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #0, #2
STRB	R0, [R1, #0]
;sin.c,91 :: 		GPIOB_CRHbits.CNF8=2;     //Output mode, max speed 2 MHz
MOVS	R2, #2
MOVW	R1, #lo_addr(GPIOB_CRHbits+0)
MOVT	R1, #hi_addr(GPIOB_CRHbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #2, #2
STRB	R0, [R1, #0]
;sin.c,92 :: 		}
L_end_init_GPIO:
BX	LR
; end of _init_GPIO
_init_PWM_sin:
;sin.c,94 :: 		void init_PWM_sin()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;sin.c,96 :: 		init_GPIO();
BL	_init_GPIO+0
;sin.c,97 :: 		init_TIM4();
BL	_init_TIM4+0
;sin.c,98 :: 		init_DMA();
BL	_init_DMA+0
;sin.c,99 :: 		}
L_end_init_PWM_sin:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _init_PWM_sin
_init_peripherals:
;sin.c,101 :: 		void init_peripherals(void)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;sin.c,103 :: 		GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_13); //led
MOVW	R1, #8192
MOVW	R0, #lo_addr(GPIOC_BASE+0)
MOVT	R0, #hi_addr(GPIOC_BASE+0)
BL	_GPIO_Digital_Output+0
;sin.c,104 :: 		GPIOC_ODR.B13=1;//off
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
STR	R1, [R0, #0]
;sin.c,106 :: 		ADC_init();
BL	_ADC_init+0
;sin.c,107 :: 		timer_3_init();
BL	_timer_3_init+0
;sin.c,109 :: 		init_PWM_sin();
BL	_init_PWM_sin+0
;sin.c,111 :: 		UART1_Init(115200);
MOV	R0, #115200
BL	_UART1_Init+0
;sin.c,112 :: 		}
L_end_init_peripherals:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _init_peripherals
_adc_buf_send:
;sin.c,114 :: 		void adc_buf_send()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;sin.c,116 :: 		unsigned int i=0;
;sin.c,117 :: 		int tempi=0;
;sin.c,118 :: 		char temp=0;
;sin.c,120 :: 		for(i=0;i<BUF_DEPTH;i++)   // put data byte after byte
; i start address is: 16 (R4)
MOVS	R4, #0
; i end address is: 16 (R4)
L_adc_buf_send3:
; i start address is: 16 (R4)
CMP	R4, #1000
IT	CS
BCS	L_adc_buf_send4
;sin.c,122 :: 		tempi=data_int[i];
LSLS	R1, R4, #1
MOVW	R0, #lo_addr(_data_int+0)
MOVT	R0, #hi_addr(_data_int+0)
ADDS	R0, R0, R1
LDRH	R0, [R0, #0]
; tempi start address is: 20 (R5)
SXTH	R5, R0
;sin.c,123 :: 		temp=tempi>>8;
SXTH	R0, R0
ASRS	R0, R0, #8
;sin.c,124 :: 		UART1_Write(temp);
UXTB	R0, R0
BL	_UART1_Write+0
;sin.c,125 :: 		temp=tempi&0x00FF;
AND	R0, R5, #255
; tempi end address is: 20 (R5)
;sin.c,126 :: 		UART1_Write(temp);
UXTB	R0, R0
BL	_UART1_Write+0
;sin.c,120 :: 		for(i=0;i<BUF_DEPTH;i++)   // put data byte after byte
ADDS	R4, R4, #1
UXTH	R4, R4
;sin.c,128 :: 		}
; i end address is: 16 (R4)
IT	AL
BAL	L_adc_buf_send3
L_adc_buf_send4:
;sin.c,130 :: 		}
L_end_adc_buf_send:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _adc_buf_send
_from_adc_to_milivolts:
;sin.c,132 :: 		void from_adc_to_milivolts(void)
;sin.c,134 :: 		unsigned int i=0;
;sin.c,135 :: 		unsigned long temp=0;
;sin.c,136 :: 		for(i=0;i<BUF_DEPTH;i++)   //
; i start address is: 12 (R3)
MOVS	R3, #0
; i end address is: 12 (R3)
L_from_adc_to_milivolts6:
; i start address is: 12 (R3)
CMP	R3, #1000
IT	CS
BCS	L_from_adc_to_milivolts7
;sin.c,138 :: 		temp=data_int[i];
LSLS	R1, R3, #1
MOVW	R0, #lo_addr(_data_int+0)
MOVT	R0, #hi_addr(_data_int+0)
ADDS	R2, R0, R1
LDRH	R0, [R2, #0]
; temp start address is: 16 (R4)
UXTH	R4, R0
;sin.c,139 :: 		temp=temp*3335;//vcc in milivolts
MOVW	R0, #3335
MUL	R1, R4, R0
; temp end address is: 16 (R4)
;sin.c,140 :: 		temp=temp/4095;
MOVW	R0, #4095
UDIV	R0, R1, R0
;sin.c,141 :: 		data_int[i]=temp;
STRH	R0, [R2, #0]
;sin.c,136 :: 		for(i=0;i<BUF_DEPTH;i++)   //
ADDS	R3, R3, #1
UXTH	R3, R3
;sin.c,142 :: 		}
; i end address is: 12 (R3)
IT	AL
BAL	L_from_adc_to_milivolts6
L_from_adc_to_milivolts7:
;sin.c,143 :: 		}
L_end_from_adc_to_milivolts:
BX	LR
; end of _from_adc_to_milivolts
_main:
;sin.c,145 :: 		void main()//
;sin.c,147 :: 		init_peripherals();
BL	_init_peripherals+0
;sin.c,149 :: 		while(1)
L_main9:
;sin.c,151 :: 		if(data_send_time==1)//
MOVW	R0, #lo_addr(_data_send_time+0)
MOVT	R0, #hi_addr(_data_send_time+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_main11
;sin.c,153 :: 		from_adc_to_milivolts();
BL	_from_adc_to_milivolts+0
;sin.c,154 :: 		adc_buf_send();
BL	_adc_buf_send+0
;sin.c,155 :: 		data_send_time=0;//start to collect new buffer
MOVS	R1, #0
MOVW	R0, #lo_addr(_data_send_time+0)
MOVT	R0, #hi_addr(_data_send_time+0)
STRB	R1, [R0, #0]
;sin.c,156 :: 		}
L_main11:
;sin.c,157 :: 		}
IT	AL
BAL	L_main9
;sin.c,158 :: 		}
L_end_main:
L__main_end_loop:
B	L__main_end_loop
; end of _main
