#line 1 "E:/temporary_work/103_breadboard/_for_libstock/sin/sin.c"








const unsigned int sinTable[ 120 ] =
{500, 526, 552, 578, 604, 629, 655, 679, 703, 727, 750, 772, 794, 815, 835, 854, 872, 889, 905, 919, 933, 946, 957, 967, 976, 983, 989, 994, 997, 999, 1000, 999, 997, 994, 989, 983, 976, 967, 957, 946, 933, 919, 905, 889, 872, 854, 835, 815, 794, 772, 750, 727, 703, 679, 655, 629, 604, 578, 552, 526, 500, 474, 448, 422, 396, 371, 345, 321, 297, 273, 250, 228, 206, 185, 165, 146, 128, 111, 95, 81, 67, 54, 43, 33, 24, 17, 11, 6, 3, 1, 0, 1, 3, 6, 11, 17, 24, 33, 43, 54, 67, 81, 95, 111, 128, 146, 165, 185, 206, 228, 250, 273, 297, 321, 345, 371, 396, 422, 448, 474};

unsigned int data_int[ 1000 ];
unsigned int num=0;
char data_send_time=0;

 void adc_inter() iv IVT_INT_ADC1_2
 {
 ADC1_SRbits.EOC=0;

 if(data_send_time==0)
 {
  GPIOC_ODR.B13 =0;
 if(num< 1000 )
 {
 data_int[num]=ADC1_DRbits.DATA;
 num++;
 }
 else
 {
 num=0;
 data_send_time=1;
 }
  GPIOC_ODR.B13 =1;
 }
 }

void timer_3_init()
 {
 RCC_APB1ENR.TIM3EN = 1;
 TIM3_CR1.CEN = 0;
 TIM3_PSC = 7199;
 TIM3_ARR = 9;
 TIM3_CR2bits.MMS=2;
 TIM3_CR1.CEN = 1;
 }

 void ADC_init(void)
 {
 GPIO_Analog_Input(&GPIOA_BASE, _GPIO_PINMASK_0);

 RCC_APB2ENRbits.ADC1EN=1;
 ADC1_CR2bits.EXTSEL=4;
 ADC1_CR2bits.EXTTRIG=1;
 ADC1_SMPR2bits.SMP0=1;
 ADC1_CR1bits.EOCIE=1;
 ADC1_CR2bits.ADON=1;
 NVIC_IntEnable(IVT_INT_ADC1_2);
 }




 void init_TIM4()
{
 RCC_APB1ENRbits.TIM4EN=1;
 TIM4_CCERbits.CC3E=1;
 TIM4_CCMR2_Outputbits.OC3M=6;
 TIM4_CCMR2_Outputbits.OC3PE=1;
 TIM4_DIERbits.CC3DE=1;
 TIM4_CR1bits.CEN=1;
 TIM4_CR1bits.ARPE=1;
 TIM4_PSC=19;
 TIM4_ARR=999;
 TIM4_CCR3=500;
}

void init_DMA()
{
 RCC_AHBENRbits.DMA1EN=1;
 DMA1_CPAR5=&TIM4_CCR3;
 DMA1_CMAR5=&sinTable;
 DMA1_CNDTR5= 120 ;
 DMA1_CCR5=0x000005B1;
}

void init_GPIO()
{
 RCC_APB2ENRbits.IOPBEN=1;
 RCC_APB2ENRbits.AFIOEN=1;
 GPIOB_CRHbits.MODE8=1;
 GPIOB_CRHbits.CNF8=2;
}

void init_PWM_sin()
{
 init_GPIO();
 init_TIM4();
 init_DMA();
}

void init_peripherals(void)
{
 GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_13);
 GPIOC_ODR.B13=1;

 ADC_init();
 timer_3_init();

 init_PWM_sin();

 UART1_Init(115200);
}

void adc_buf_send()
{
 unsigned int i=0;
 int tempi=0;
 char temp=0;

 for(i=0;i< 1000 ;i++)
 {
 tempi=data_int[i];
 temp=tempi>>8;
 UART1_Write(temp);
 temp=tempi&0x00FF;
 UART1_Write(temp);

 }

}

void from_adc_to_milivolts(void)
{
 unsigned int i=0;
 unsigned long temp=0;
 for(i=0;i< 1000 ;i++)
 {
 temp=data_int[i];
 temp=temp*3335;
 temp=temp/4095;
 data_int[i]=temp;
 }
}

void main()
{
 init_peripherals();

 while(1)
 {
 if(data_send_time==1)
 {
 from_adc_to_milivolts();
 adc_buf_send();
 data_send_time=0;
 }
 }
}
